#include <bits/stdc++.h>

using namespace std;

const int MAXN = 111111;

struct Person {
    int i;
    int time;
    int floor;

    bool operator< (const Person &other) const {
        return tie(i, time, floor) < tie(other.i, other.time, other.floor);
    }

};

Person ps[MAXN];
long long times[MAXN];
int with[MAXN];

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0); cout.precision(15); cout << fixed;
    int n, m;
    cin >> n >> m;
    set<pair<int, int>> st;
    set<Person> a;
    for (int i = 0; i < n; ++i) {
        int t, f;
        cin >> t >> f;
        ps[i] = {i, t, f};
        st.insert({t + f, i});
        a.insert({i, t, f});
    }
    long long t = 0LL;
    int order = 0;
    while (!a.empty()) {
        auto first = *a.begin();
        with[first.i] = order;
        first = {first.i, first.time, first.floor};
        a.erase(a.begin());
        st.erase({ps[first.i].time + ps[first.i].floor, first.i});
        long long resTime = max(t, 1LL * first.time) + first.floor - 1;
        auto it = st.begin();
        while (!st.empty() && it->first <= resTime + first.floor) {
            auto cand = *it;
            int i = cand.second;
            if (ps[i].floor > ps[first.i].floor) {
                ++it;
                continue;
            }
            with[i] = order;
            cand = {cand.first, cand.second};
            cerr << i << " " << first.i << endl;
            st.erase(st.begin());
            a.erase({i, ps[i].time, ps[i].floor});
            it = st.begin();
        }
        times[order] = resTime + first.floor - 1;
        t = times[order];
        ++order;
    }
    for (int i = 0; i < n; ++i) {
        cout << times[with[i]] << endl;
    }
    return 0;
}
