#include <bits/stdc++.h>

using namespace std;

const int MAXN = 111111;

struct Person {
    int time;
    int floor;
    bool done;
    int with;
};

Person a[MAXN];
int ans[MAXN];
int times[MAXN];

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0); cout.precision(15); cout << fixed;
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) {
        int t, f;
        cin >> t >> f;
        a[i] = {t, f, 0, -1};
    }
    int left = n;
    long long t = 0LL;
    int order = 0;
    while (left) { //O(n)
//        cerr << t << endl;
        int first = -1;
        for (int i = 0; i < n; ++i) { //O(n)
            if (!a[i].done) {
                first = i;
                break;
            }
        }
        long long resTime = max(t, 1LL * a[first].time) + a[first].floor - 1;
        for (int i = 0; i < n; ++i) { //O(n)
            if (a[i].done) continue;
            if (a[i].floor > a[first].floor) continue;
            long long timeToGet = resTime + a[first].floor - a[i].floor;
            if (a[i].time <= timeToGet) {
                a[i].done = 1;
                a[i].with = order;
                --left;
//                cerr << i << " " << timeToGet << endl;
            }
        }
        times[order] = resTime + a[first].floor - 1;
        t = times[order];
        ++order;
    }
    for (int i = 0; i < n; ++i) {
        cout << times[a[i].with] << endl;
    }
    return 0;
}
