#include <bits/stdc++.h>

using namespace std;

const int MAXN = 111111;

struct Person {
    int time;
    int i;
    int floor;

    bool operator< (const Person &other) const {
        return tie(i, time, floor) < tie(other.time, other.i, other.floor);
    }

};

Person ps[MAXN];
long long times[MAXN];
int with[MAXN];

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0); cout.precision(15); cout << fixed;
    int n, m;
    cin >> n >> m;
    set<pair<int, int>> st;
    set<int> a;
    for (int i = 0; i < n; ++i) {
        int t, f;
        cin >> t >> f;
        ps[i] = {t, i, f};
        st.insert({t + f, i});
        a.insert(i);
    }
    long long t = 0LL;
    int order = 0;
    while (!a.empty()) {
        int i = *a.begin();
        with[i] = order;
        int first = i;
        a.erase(a.begin());
        st.erase({ps[first].time + ps[first].floor, first});
        long long resTime = max(t, 1LL * ps[first].time) + ps[first].floor - 1;
        auto it = st.begin();
        while (!st.empty() && it->first <= resTime + ps[first].floor) {
            auto cand = *it;
            int j = cand.second;
            if (ps[j].floor > ps[first].floor) {
                ++it;
                continue;
            }
//            cerr << i << " " << j << endl;
            with[j] = order;
            cand = {cand.first, cand.second};
            st.erase(st.begin());
            a.erase(j);
            it = st.begin();
        }
        times[order] = resTime + ps[first].floor - 1;
        t = times[order];
        ++order;
    }
    for (int i = 0; i < n; ++i) {
        cout << times[with[i]] << endl;
    }
    return 0;
}
