import java.io.*;
import java.util.*;

public class B {
	
	public void solve() throws IOException {
        int k = nextInt();
        long s = nextLong();
        long left = 0;
        long right = s + 20;
        while (left < right) {
        	long deleted = (left + right) / 2;
        	// (k + 1)...(k + deleted + 1); (2k + 3)...(2(k + deleted) + 3)
        	long t = (2 * s - deleted * (deleted + 1) + k + k + deleted
        			+ deleted - 1) / (k + k + deleted + deleted);
        	long leftBound = t * k + (t * (t + 1) + 1) / 2;
        	if (leftBound <= s) {
        		right = deleted;
        	} else {
        		left = deleted + 1;
        	}
        }
        out.println(left + k);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}
