import java.io.*;
import java.util.*;

public class B {
	
	public void solve() throws IOException {
        int k = nextInt();
        long s = nextLong();
        long left = 0;
        long right = s + 20;
        for (int jt = 0; jt < 100; ++jt) {
        	long i = (left + right) / 2;
        	long l = -1;
        	long r = (int) 1e9;
        	for (int it = 0; it < 100; ++it) {
        		long t = (l + r) / 2;
        		if ((t * (k + i) + t * (t + 1) / 2) >= s) {
        			r = t;
        		} else {
        			l = t;
        		}
        	}
        	long leftBound = r * k + (r * (r + 1) + 1) / 2;
            if (leftBound <= s) {
                right = i;
            } else {
                left = i + 1;
            }
        }
        out.println(right + k);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}
