import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class B {
	
	public void solve() throws IOException {
        int k = nextInt();
        long s = nextLong();
        BigInteger sBig = BigInteger.valueOf(s);
        BigInteger kBig = BigInteger.valueOf(k);
        long left = 0;
        long right = s + 20;
        for (int jt = 0; jt < 500; ++jt) {
        	long i = (left + right) / 2;
        	long l = -1;
        	long r = (long) 1e18;
        	for (int it = 0; it < 500; ++it) {
        		BigInteger t = BigInteger.valueOf((l + r) / 2);
        		BigInteger ki = BigInteger.valueOf(k + i);
        		if ((t.multiply(ki).add(t.multiply(t.add(BigInteger.ONE))
        				.divide(BigInteger.valueOf(2)))).compareTo(sBig) >= 0) {
        			r = t.longValue();
        		} else {
        			l = t.longValue();
        		}
        	}
        	BigInteger rBig = BigInteger.valueOf(r);
        	BigInteger leftBound = rBig.multiply(kBig).add(rBig.multiply(rBig.add(BigInteger.ONE)).add(BigInteger.ONE).divide(BigInteger.valueOf(2)));
            if (leftBound.compareTo(sBig) <= 0) {
                right = i;
            } else {
                left = i + 1;
            }
        }
        out.println(right + k);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in)); 
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}
