#include <bits/stdc++.h>

using namespace std;

#define all(x) (x).begin(), (x).end()

vector<vector<int>> g;
vector<int> used;

int dfs(int v, int p) {
    used[v] = 1;
    int res = 1;
    for (int x: g[v]) {
        if (x == p) continue;
        if (!used[x]) {
            res = max(res, 1 + dfs(x, v));
        }
    }
    return res;
}

int main()
{
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0); cout.precision(15); cout << fixed;
    int n, m;
    cin >> n >> m;
    g.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int p;
        cin >> p;
        g[p - 1].push_back(i + 1);
        g[i + 1].push_back(p - 1);
    }
    if (m == 2) {
        cout << 10 << endl;
        return 0;
    }
    int mx = -1;
    for (int i = 0; i < n; ++i) {
        used.assign(n, 0);
        mx = max(mx, dfs(i, -1));
    }
    cout << mx << endl;
    return 0;
}
